diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/tx-duration-test.cc ns-3.45/src/wifi/test/tx-duration-test.cc
--- ns-3.44/src/wifi/test/tx-duration-test.cc	2025-03-09 16:55:49.807372600 -0700
+++ ns-3.45/src/wifi/test/tx-duration-test.cc	2025-06-01 20:34:45.634702200 -0700
@@ -1457,51 +2036,59 @@
      * @param userInfos the HE MU specific per-user information to use for the test
      * @param sigBMode the mode to transmit HE-SIG-B for the test
      * @param channelWidth the channel width to select for the test
+     * @param p20Index the index of the primary20 channel
      * @param expectedMuType the expected MU type (OFDMA or MU-MIMO)
-     * @param expectedRuAllocation the expected RU_ALLOCATION
+     * @param expectedRuAllocation the expected RuType::RU_ALLOCATION
      * @param expectedNumUsersPerCc the expected number of users per content channel
      * @param expectedSigBDuration the expected duration of the HE-SIG-B header
      */
-    HeSigBDurationTest(const std::list<HeMuUserInfo>& userInfos,
-                       const WifiMode& sigBMode,
-                       MHz_u channelWidth,
-                       MuType expectedMuType,
-                       const RuAllocation& expectedRuAllocation,
-                       const std::pair<std::size_t, std::size_t>& expectedNumUsersPerCc,
-                       Time expectedSigBDuration);
+    MuSigDurationTest(const std::list<HeMuUserInfo>& userInfos,
+                      const WifiMode& sigBMode,
+                      MHz_u channelWidth,
+                      uint8_t p20Index,
+                      MuType expectedMuType,
+                      const RuAllocation& expectedRuAllocation,
+                      const std::pair<std::size_t, std::size_t>& expectedNumUsersPerCc,
+                      Time expectedSigBDuration);
 
   private:
     void DoRun() override;
+    void DoTeardown() override;
 
     /**
-     * Build a TXVECTOR for HE MU.
+     * Build a TXVECTOR for HE MU or EHT MU.
      *
-     * @return the configured HE MU TXVECTOR
+     * @return the configured TXVECTOR for HE MU or EHT MU
      */
     WifiTxVector BuildTxVector() const;
 
+    Ptr<YansWifiPhy> m_phy; ///< the PHY under test
+
     std::list<HeMuUserInfo> m_userInfos; ///< HE MU specific per-user information
     WifiMode m_sigBMode;                 ///< Mode used to transmit HE-SIG-B
     MHz_u m_channelWidth;                ///< Channel width
+    uint8_t m_p20Index;                  ///< index of the primary20 channel
     MuType m_expectedMuType;             ///< Expected MU type (OFDMA or MU-MIMO)
-    RuAllocation m_expectedRuAllocation; ///< Expected RU_ALLOCATION
+    RuAllocation m_expectedRuAllocation; ///< Expected RuType::RU_ALLOCATION
     std::pair<std::size_t, std::size_t>
         m_expectedNumUsersPerCc; ///< Expected number of users per content channel
-    Time m_expectedSigBDuration; ///< Expected duration of the HE-SIG-B header
+    Time m_expectedSigBDuration; ///< Expected duration of the HE-SIG-B/EHT-SIG header
 };
 
-HeSigBDurationTest::HeSigBDurationTest(
+MuSigDurationTest::MuSigDurationTest(
     const std::list<HeMuUserInfo>& userInfos,
     const WifiMode& sigBMode,
     MHz_u channelWidth,
+    uint8_t p20Index,
     MuType expectedMuType,
     const RuAllocation& expectedRuAllocation,
     const std::pair<std::size_t, std::size_t>& expectedNumUsersPerCc,
     Time expectedSigBDuration)
-    : TestCase{"Check HE-SIG-B duration computation"},
+    : TestCase{"Check HE-SIG-B or EHT-SIG duration computation"},
       m_userInfos{userInfos},
       m_sigBMode{sigBMode},
       m_channelWidth{channelWidth},
+      m_p20Index{p20Index},
       m_expectedMuType{expectedMuType},
       m_expectedRuAllocation{expectedRuAllocation},
       m_expectedNumUsersPerCc{expectedNumUsersPerCc},
@@ -1510,16 +2097,21 @@
 }
 
 WifiTxVector
-HeSigBDurationTest::BuildTxVector() const
+MuSigDurationTest::BuildTxVector() const
 {
+    const auto isHe = WifiRu::IsHe(m_userInfos.begin()->ru);
     WifiTxVector txVector;
-    txVector.SetPreambleType(WIFI_PREAMBLE_HE_MU);
+    txVector.SetPreambleType(isHe ? WIFI_PREAMBLE_HE_MU : WIFI_PREAMBLE_EHT_MU);
     txVector.SetChannelWidth(m_channelWidth);
     txVector.SetGuardInterval(NanoSeconds(3200));
     txVector.SetStbc(false);
     txVector.SetNess(0);
     std::list<uint16_t> staIds;
     uint16_t staId = 1;
+    if (!isHe)
+    {
+        txVector.SetEhtPpduType(0);
+    }
     for (const auto& userInfo : m_userInfos)
     {
         txVector.SetHeMuUserInfo(staId, userInfo);
@@ -1531,45 +2123,95 @@
 }
 
 void
-HeSigBDurationTest::DoRun()
+MuSigDurationTest::DoRun()
 {
-    const auto& hePhy = WifiPhy::GetStaticPhyEntity(WIFI_MOD_CLASS_HE);
+    m_phy = CreateObject<YansWifiPhy>();
+    auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
+                                                         MHz_u{0},
+                                                         MHz_u{320},
+                                                         WIFI_STANDARD_80211be,
+                                                         WIFI_PHY_BAND_6GHZ)
+                          ->number;
+    m_phy->SetOperatingChannel(
+        WifiPhy::ChannelTuple{channelNum, 320, WIFI_PHY_BAND_6GHZ, m_p20Index});
+    m_phy->ConfigureStandard(WIFI_STANDARD_80211be);
+
     const auto& txVector = BuildTxVector();
+    auto phyEntity = m_phy->GetPhyEntity(txVector.GetModulationClass());
 
-    // Verify mode for HE-SIG-B field
-    NS_TEST_EXPECT_MSG_EQ(hePhy->GetSigMode(WIFI_PPDU_FIELD_SIG_B, txVector),
+    // Verify mode for HE-SIG-B/EHT-SIG field
+    NS_TEST_EXPECT_MSG_EQ(phyEntity->GetSigMode(WIFI_PPDU_FIELD_SIG_B, txVector),
                           m_sigBMode,
-                          "Incorrect mode used to send HE-SIG-B");
+                          "Incorrect mode used to send HE-SIG-B/EHT-SIG");
 
-    // Verify RU_ALLOCATION in TXVECTOR
+    // Verify RuType::RU_ALLOCATION in TXVECTOR
     NS_TEST_EXPECT_MSG_EQ((txVector.GetRuAllocation(0) == m_expectedRuAllocation),
                           true,
-                          "Incorrect RU_ALLOCATION");
+                          "Incorrect RuType::RU_ALLOCATION");
 
     // Verify number of users for content channels 1 and 2
     const auto& numUsersPerCc = HePpdu::GetNumRusPerHeSigBContentChannel(
         txVector.GetChannelWidth(),
-        txVector.GetRuAllocation(0),
+        txVector.GetModulationClass(),
+        txVector.GetRuAllocation(m_p20Index),
+        txVector.GetCenter26ToneRuIndication(),
         txVector.IsSigBCompression(),
         txVector.IsSigBCompression() ? txVector.GetHeMuUserInfoMap().size() : 0);
     const auto contentChannels = HePpdu::GetHeSigBContentChannels(txVector, 0);
     NS_TEST_EXPECT_MSG_EQ(numUsersPerCc.first,
                           m_expectedNumUsersPerCc.first,
-                          "Incorrect number of users in HE-SIG-B content channel 1");
+                          "Incorrect number of users in content channel 1");
     NS_TEST_EXPECT_MSG_EQ(numUsersPerCc.second,
                           m_expectedNumUsersPerCc.second,
-                          "Incorrect number of users in HE-SIG-B content channel 2");
+                          "Incorrect number of users in content channel 2");
     NS_TEST_EXPECT_MSG_EQ(contentChannels.at(0).size(),
                           m_expectedNumUsersPerCc.first,
-                          "Incorrect number of users in HE-SIG-B content channel 1");
+                          "Incorrect number of users in content channel 1");
     NS_TEST_EXPECT_MSG_EQ((contentChannels.size() > 1 ? contentChannels.at(1).size() : 0),
                           m_expectedNumUsersPerCc.second,
-                          "Incorrect number of users in HE-SIG-B content channel 2");
+                          "Incorrect number of users in content channel 2");
+
+    // Verify total HE-SIG-B/EHT-SIG duration
+    if (txVector.GetModulationClass() == WIFI_MOD_CLASS_HE)
+    {
+        NS_TEST_EXPECT_MSG_EQ(phyEntity->GetDuration(WIFI_PPDU_FIELD_SIG_B, txVector),
+                              m_expectedSigBDuration,
+                              "Incorrect duration for HE-SIG-B");
+    }
+    else // EHT
+    {
+        NS_TEST_EXPECT_MSG_EQ(phyEntity->GetDuration(WIFI_PPDU_FIELD_EHT_SIG, txVector),
+                              m_expectedSigBDuration,
+                              "Incorrect duration for EHT-SIG");
+    }
+
+    // Verify user infos in reconstructed TX vector
+    WifiConstPsduMap psdus;
+    Time ppduDuration;
+    for (std::size_t i = 0; i < m_userInfos.size(); ++i)
+    {
+        WifiMacHeader hdr;
+        auto psdu = Create<WifiPsdu>(Create<Packet>(1000), hdr);
+        ppduDuration = std::max(
+            ppduDuration,
+            WifiPhy::CalculateTxDuration(psdu->GetSize(), txVector, m_phy->GetPhyBand(), i + 1));
+        psdus.insert(std::make_pair(i, psdu));
+    }
+    auto ppdu = phyEntity->BuildPpdu(psdus, txVector, ppduDuration);
+    ppdu->ResetTxVector();
+    const auto& rxVector = ppdu->GetTxVector();
+    NS_TEST_EXPECT_MSG_EQ((txVector.GetHeMuUserInfoMap() == rxVector.GetHeMuUserInfoMap()),
+                          true,
+                          "Incorrect user infos in reconstructed TXVECTOR");
 
-    // Verify total HE-SIG-B duration
-    NS_TEST_EXPECT_MSG_EQ(hePhy->GetDuration(WIFI_PPDU_FIELD_SIG_B, txVector),
-                          m_expectedSigBDuration,
-                          "Incorrect duration for HE-SIG-B");
+    Simulator::Destroy();
+}
+
+void
+MuSigDurationTest::DoTeardown()
+{
+    m_phy->Dispose();
+    m_phy = nullptr;
 }
 
 /**
@@ -1816,8 +2458,9 @@
     txVector.SetNss(2); // HE-LTF duration assumed to be always 8 us for the time being (see note in
                         // HePhy::GetTrainingDuration)
     txVector.SetMode(HePhy::GetHeMcs9());
-    std::map<uint16_t, HeMuUserInfo> userInfoMap = {{1, {{HeRu::RU_106_TONE, 1, true}, 4, 2}},
-                                                    {2, {{HeRu::RU_106_TONE, 1, true}, 9, 1}}};
+    std::map<uint16_t, HeMuUserInfo> userInfoMap = {
+        {1, {HeRu::RuSpec{RuType::RU_106_TONE, 1, true}, 4, 2}},
+        {2, {HeRu::RuSpec{RuType::RU_106_TONE, 1, true}, 9, 1}}};
     sigAMode = HePhy::GetVhtMcs0();
     sigBMode = HePhy::GetVhtMcs4(); // because of first user info map
 
@@ -1888,8 +2531,10 @@
     txVector.SetNss(2); // EHT-LTF duration assumed to be always 8 us for the time being (see note
                         // in HePhy::GetTrainingDuration)
     txVector.SetMode(EhtPhy::GetEhtMcs9());
-    userInfoMap = {{1, {{HeRu::RU_106_TONE, 1, true}, 4, 2}},
-                   {2, {{HeRu::RU_106_TONE, 1, true}, 9, 1}}};
+    userInfoMap = {{1, {EhtRu::RuSpec{RuType::RU_52_TONE, 1, true, true}, 4, 2}},
+                   {2, {EhtRu::RuSpec{RuType::RU_52_TONE, 2, true, true}, 9, 1}},
+                   {3, {EhtRu::RuSpec{RuType::RU_52_TONE, 3, true, true}, 4, 2}},
+                   {4, {EhtRu::RuSpec{RuType::RU_52_TONE, 4, true, true}, 9, 1}}};
     WifiMode uSigMode = EhtPhy::GetVhtMcs0();
     WifiMode ehtSigMode = EhtPhy::GetVhtMcs4(); // because of first user info map
 
@@ -1908,7 +2553,7 @@
     // -> EHT MU format
     txVector.SetPreambleType(WIFI_PREAMBLE_EHT_MU);
     txVector.SetEhtPpduType(0); // EHT MU transmission
-    txVector.SetRuAllocation({96}, 0);
+    txVector.SetRuAllocation({24}, 0);
     sections[WIFI_PPDU_FIELD_U_SIG] = {{ppduStart + MicroSeconds(24), ppduStart + MicroSeconds(32)},
                                        uSigMode};
     sections[WIFI_PPDU_FIELD_EHT_SIG] = {
@@ -1920,7 +2565,7 @@
         ehtSigMode};
     CheckPhyHeaderSections(phyEntity->GetPhyHeaderSections(txVector, ppduStart), sections);
     txVector.SetChannelWidth(MHz_u{160}); // shouldn't have any impact
-    txVector.SetRuAllocation({96, 113, 113, 113, 113, 113, 113, 113}, 0);
+    txVector.SetRuAllocation({24, 27, 27, 27, 27, 27, 27, 27}, 0);
 
     CheckPhyHeaderSections(phyEntity->GetPhyHeaderSections(txVector, ppduStart), sections);
 }
